<template>
  <div class="app-container">
    <!-- 对话框(添加 / 修改) -->
    <el-dialog
      v-dialogDrag
      :title="dialogTitle"
      :visible.sync="dialogVisible"
      width="45%"
      append-to-body
    >
      <el-form
        ref="formRef"
        v-loading="formLoading"
        :model="formData"
        :rules="formRules"
        label-width="100px"
      >
        <el-form-item label="名字" prop="name">
          <el-input v-model="formData.name" placeholder="请输入名字" />
        </el-form-item>
        <el-form-item label="性别" prop="sex">
          <el-radio-group v-model="formData.sex">
            <el-radio
              v-for="dict in getDictDatas(DICT_TYPE.SYSTEM_USER_SEX)"
              :key="dict.value"
              :label="dict.value"
            >{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="出生日期" prop="birthday">
          <el-date-picker
            v-model="formData.birthday"
            clearable
            type="date"
            value-format="timestamp"
            placeholder="选择出生日期"
          />
        </el-form-item>
        <el-form-item label="简介">
          <Editor v-model="formData.description" :min-height="192" />
        </el-form-item>
      </el-form>
      <!-- 子表的表单 -->
      <el-tabs v-model="subTabsName">
        <el-tab-pane label="学生班级表3" name="demo03Grade3">
          <Demo03Grade3Form ref="demo03Grade3FormRef" :student-id="formData.id" />
        </el-tab-pane>
        <el-tab-pane label="学生课程表3" name="demo03Course3">
          <Demo03Course3Form ref="demo03Course3FormRef" :student-id="formData.id" />
        </el-tab-pane>
      </el-tabs>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" :disabled="formLoading" @click="submitForm">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import * as Demo03Student3Api from '@/api/infra/testDemo/student3'
import Editor from '@/components/Editor'
import Demo03Grade3Form from './components/Demo03Grade3Form.vue'
import Demo03Course3Form from './components/Demo03Course3Form.vue'
export default {
  name: 'Demo03Student3Form',
  components: {
    Editor,
    Demo03Grade3Form,
    Demo03Course3Form
  },
  data() {
    return {
      // 弹出层标题
      dialogTitle: '',
      // 是否显示弹出层
      dialogVisible: false,
      // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
      formLoading: false,
      // 表单参数
      formData: {
        id: undefined,
        name: undefined,
        sex: undefined,
        birthday: undefined,
        description: undefined
      },
      // 表单校验
      formRules: {
        name: [{ required: true, message: '名字不能为空', trigger: 'blur' }],
        sex: [{ required: true, message: '性别不能为空', trigger: 'blur' }],
        birthday: [{ required: true, message: '出生日期不能为空', trigger: 'blur' }],
        description: [{ required: true, message: '简介不能为空', trigger: 'blur' }]
      },
      /** 子表的表单 */
      subTabsName: 'demo03Grade3'
    }
  },
  methods: {
    /** 打开弹窗 */
    async open(id) {
      this.dialogVisible = true
      this.reset()
      // 修改时，设置数据
      if (id) {
        this.formLoading = true
        try {
          const res = await Demo03Student3Api.getDemo03Student3(id)
          this.formData = res.data
          this.title = '修改内嵌主子表'
        } finally {
          this.formLoading = false
        }
      }
      this.title = '新增内嵌主子表'
    },
    /** 提交按钮 */
    async submitForm() {
      // 校验主表
      await this.$refs['formRef'].validate()
      // 校验子表
      try {
        await this.$refs['demo03Grade3FormRef'].validate()
      } catch (e) {
        this.subTabsName = 'demo03Grade3'
        return
      }
      try {
        await this.$refs['demo03Course3FormRef'].validate()
      } catch (e) {
        this.subTabsName = 'demo03Course3'
        return
      }
      this.formLoading = true
      try {
        const data = this.formData
        // 拼接子表的数据
        data.demo03Grade3 = this.$refs['demo03Grade3FormRef'].getData()
        data.demo03Course3s = this.$refs['demo03Course3FormRef'].getData()
        // 修改的提交
        if (data.id) {
          await Demo03Student3Api.updateDemo03Student3(data)
          this.$modal.msgSuccess('修改成功')
          this.dialogVisible = false
          this.$emit('success')
          return
        }
        // 添加的提交
        await Demo03Student3Api.createDemo03Student3(data)
        this.$modal.msgSuccess('新增成功')
        this.dialogVisible = false
        this.$emit('success')
      } finally {
        this.formLoading = false
      }
    },
    /** 表单重置 */
    reset() {
      this.formData = {
        id: undefined,
        name: undefined,
        sex: undefined,
        birthday: undefined,
        description: undefined
      }
      this.resetForm('formRef')
    }
  }
}
</script>
